module String where

import Graphics.UI.GLUT
import Foreign.C.String ( castCharToCChar )
import Control.Monad
import Data.IORef
import Data.List ( genericDrop , genericLength )
import Foreign.Marshal.Array ( withArray )




symbols :: [[GLubyte]]
symbols = [
  [ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 ], --
  [ 0x00, 0x00, 0x30, 0x30, 0x00, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30 ], -- !
  [ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x66, 0x66 ], -- "
  [ 0x00, 0x00, 0x48, 0x48, 0x48, 0xff, 0x24, 0x24, 0x24, 0xff, 0x12, 0x12, 0x12 ], -- #
  [ 0x00, 0x00, 0x00, 0x3c, 0x66, 0x06, 0x1e, 0x78, 0x60, 0x66, 0x3c, 0x00, 0x00 ], -- $ --
  [ 0x00, 0x00, 0x66, 0x69, 0x36, 0x30, 0x18, 0x18, 0x0c, 0x0c, 0x66, 0x96, 0x62 ], -- %
  [ 0x00, 0x00, 0x7b, 0xc6, 0xc7, 0xcd, 0x6c, 0x38, 0x3c, 0x66, 0x66, 0x66, 0x3c ], -- &
  [ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x60, 0x60, 0x60 ], -- '
  [ 0x03, 0x06, 0x0c, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x0c, 0x0c, 0x06, 0x03 ], -- (
  [ 0xc0, 0x60, 0x30, 0x30, 0x18, 0x18, 0x18, 0x18, 0x18, 0x30, 0x30, 0x60, 0xc0 ], -- )
  [ 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 ], -- *
  [ 0x00, 0x00, 0x00, 0x18, 0x18, 0x7e, 0x7e, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00 ], -- +
  [ 0x80, 0xc0, 0x60, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 ], -- ,
  [ 0x00, 0x00, 0x00, 0x00, 0x00, 0x7e, 0x7e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 ], -- -
  [ 0x00, 0x00, 0x60, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 ], -- .
  [ 0x00, 0x00, 0x60, 0x60, 0x30, 0x30, 0x18, 0x18, 0x0c, 0x0c, 0x06, 0x06, 0x02 ], -- /
  [ 0x00, 0x00, 0x7e, 0xe7, 0xc3, 0xc3, 0xc3, 0xff, 0xc3, 0xc3, 0xc3, 0xe7, 0x7e ], -- 0
  [ 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0xd8, 0x78, 0x38 ], -- 1
  [ 0x00, 0x00, 0xff, 0xc0, 0x60, 0x30, 0x18, 0x0c, 0x06, 0x03, 0x03, 0xe7, 0x7e ], -- 2
  [ 0x00, 0x00, 0x7e, 0xe7, 0x03, 0x03, 0x06, 0x0c, 0x06, 0x03, 0x03, 0xe7, 0x7e ], -- 3
  [ 0x00, 0x00, 0x0c, 0x0c, 0x0c, 0xff, 0xff, 0xcc, 0xcc, 0x6c, 0x3c, 0x1c, 0x0c ], -- 4
  [ 0x00, 0x00, 0x7e, 0xe7, 0x03, 0x03, 0x07, 0x1e, 0x78, 0xc0, 0xc0, 0xc0, 0xff ], -- 5
  [ 0x00, 0x00, 0x7e, 0xc3, 0xc3, 0xc3, 0xc3, 0xff, 0xde, 0xc0, 0xc0, 0xe7, 0x7e ], -- 6
  [ 0x00, 0x00, 0xc0, 0xc0, 0xc0, 0xc0, 0x60, 0x30, 0x18, 0x0c, 0x06, 0x03, 0xff ], -- 7
  [ 0x00, 0x00, 0x7e, 0xe7, 0xc3, 0xc3, 0xe7, 0x7e, 0xe7, 0xc3, 0xc3, 0xe7, 0x7e ], -- 8
  [ 0x00, 0x00, 0x7e, 0xc3, 0x03, 0x03, 0x03, 0x3f, 0x67, 0xc3, 0xc3, 0xc3, 0x7e ], -- 9
  [ 0x00, 0x00, 0x60, 0x60, 0x00, 0x00, 0x00, 0x00, 0x60, 0x60, 0x00, 0x00, 0x00 ], -- :
  [ 0x80, 0xc0, 0x60, 0x60, 0x00, 0x00, 0x00, 0x00, 0x60, 0x60, 0x00, 0x00, 0x00 ]] -- ;

upperLetters :: [[GLubyte]]
upperLetters = [
  [ 0x00, 0x00, 0xc3, 0xc3, 0xc3, 0xc3, 0xff, 0xc3, 0xc3, 0xc3, 0x66, 0x3c, 0x18 ], -- A
  [ 0x00, 0x00, 0xfe, 0xc7, 0xc3, 0xc3, 0xc7, 0xfe, 0xc7, 0xc3, 0xc3, 0xc7, 0xfe ], -- B
  [ 0x00, 0x00, 0x7e, 0xe7, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xe7, 0x7e ], -- C
  [ 0x00, 0x00, 0xfc, 0xce, 0xc7, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc7, 0xce, 0xfc ], -- D
  [ 0x00, 0x00, 0xff, 0xc0, 0xc0, 0xc0, 0xc0, 0xfc, 0xc0, 0xc0, 0xc0, 0xc0, 0xff ], -- E
  [ 0x00, 0x00, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xfc, 0xc0, 0xc0, 0xc0, 0xff ], -- F
  [ 0x00, 0x00, 0x7e, 0xe7, 0xc3, 0xc3, 0xcf, 0xc0, 0xc0, 0xc0, 0xc0, 0xe7, 0x7e ], -- G
  [ 0x00, 0x00, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xff, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3 ], -- H
  [ 0x00, 0x00, 0x7e, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x7e ], -- I
  [ 0x00, 0x00, 0x7c, 0xee, 0xc6, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06 ], -- J
  [ 0x00, 0x00, 0xc3, 0xc6, 0xcc, 0xd8, 0xf0, 0xe0, 0xf0, 0xd8, 0xcc, 0xc6, 0xc3 ], -- K
  [ 0x00, 0x00, 0xff, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0 ], -- L
  [ 0x00, 0x00, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xdb, 0xff, 0xff, 0xe7, 0xc3 ], -- M
  [ 0x00, 0x00, 0xc7, 0xc7, 0xcf, 0xcf, 0xdf, 0xdb, 0xfb, 0xf3, 0xf3, 0xe3, 0xe3 ], -- N
  [ 0x00, 0x00, 0x7e, 0xe7, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xe7, 0x7e ], -- O
  [ 0x00, 0x00, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xfe, 0xc7, 0xc3, 0xc3, 0xc7, 0xfe ], -- P
  [ 0x00, 0x00, 0x3f, 0x6e, 0xdf, 0xdb, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0x66, 0x3c ], -- Q
  [ 0x00, 0x00, 0xc3, 0xc6, 0xcc, 0xd8, 0xf0, 0xfe, 0xc7, 0xc3, 0xc3, 0xc7, 0xfe ], -- R
  [ 0x00, 0x00, 0x7e, 0xe7, 0x03, 0x03, 0x07, 0x7e, 0xe0, 0xc0, 0xc0, 0xe7, 0x7e ], -- S
  [ 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0xff ], -- T
  [ 0x00, 0x00, 0x7e, 0xe7, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3 ], -- U
  [ 0x00, 0x00, 0x18, 0x3c, 0x3c, 0x66, 0x66, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3 ], -- V
  [ 0x00, 0x00, 0xc3, 0xe7, 0xff, 0xff, 0xdb, 0xdb, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3 ], -- W
  [ 0x00, 0x00, 0xc3, 0x66, 0x66, 0x3c, 0x3c, 0x18, 0x3c, 0x3c, 0x66, 0x66, 0xc3 ], -- X
  [ 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3c, 0x3c, 0x66, 0x66, 0xc3 ], -- Y
  [ 0x00, 0x00, 0xff, 0xc0, 0xc0, 0x60, 0x30, 0x7e, 0x0c, 0x06, 0x03, 0x03, 0xff ]] -- Z

lowerLetters :: [[GLubyte]]
lowerLetters = [
  [ 0x00, 0x00, 0x7f, 0xc3, 0xc3, 0xc3, 0x7f, 0x03, 0xc3, 0x7e, 0x00, 0x00, 0x00 ], -- a
  [ 0x00, 0x00, 0xde, 0xe3, 0xc3, 0xc3, 0xc3, 0xc3, 0xe3, 0xde, 0xc0, 0xc0, 0xc0 ], -- b
  [ 0x00, 0x00, 0x7e, 0xc3, 0xc0, 0xc0, 0xc0, 0xc0, 0xc3, 0x7e, 0x00, 0x00, 0x00 ], -- c
  [ 0x00, 0x00, 0x7b, 0xc7, 0xc3, 0xc3, 0xc3, 0xc3, 0xc7, 0x7b, 0x03, 0x03, 0x03 ], -- d
  [ 0x00, 0x00, 0x3c, 0x66, 0xc0, 0xc0, 0xff, 0xc3, 0x66, 0x3c, 0x00, 0x00, 0x00 ], -- e
  [ 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0xff, 0xff, 0x18, 0x18, 0x1c, 0x0f ], -- f
  [ 0x7e, 0x07, 0x7b, 0xc7, 0xc3, 0xc3, 0xc3, 0xc3, 0xc7, 0x7b, 0x00, 0x00, 0x00 ], -- g
  [ 0x00, 0x00, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xe3, 0xde, 0xc0, 0xc0, 0xc0 ], -- h
  [ 0x00, 0x00, 0x7e, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x78, 0x00, 0x18, 0x18 ], -- i
  [ 0xf0, 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x78, 0x00, 0x18, 0x18 ], -- j
  [ 0x00, 0x00, 0xc3, 0xc6, 0xec, 0xf8, 0xd8, 0xcc, 0xc6, 0xc3, 0xc0, 0xc0, 0xc0 ], -- k
  [ 0x00, 0x00, 0x0f, 0x1f, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18 ], -- l
  [ 0x00, 0x00, 0xdb, 0xdb, 0xdb, 0xdb, 0xdb, 0xdb, 0xff, 0xdb, 0x00, 0x00, 0x00 ], -- m
  [ 0x00, 0x00, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xe7, 0xde, 0x00, 0x00, 0x00 ], -- n
  [ 0x00, 0x00, 0x3c, 0x66, 0xc3, 0xc3, 0xc3, 0xc3, 0x66, 0x3c, 0x00, 0x00, 0x00 ], -- o
  [ 0xc0, 0xc0, 0xde, 0xe3, 0xc3, 0xc3, 0xc3, 0xc3, 0xe3, 0xde, 0x00, 0x00, 0x00 ], -- p
  [ 0x03, 0x03, 0x7b, 0xe7, 0xc3, 0xc3, 0xc3, 0xc3, 0xe7, 0x7b, 0x00, 0x00, 0x00 ], -- q
  [ 0x00, 0x00, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xe3, 0xde, 0x00, 0x00, 0x00 ], -- r
  [ 0x00, 0x00, 0x3c, 0x66, 0x06, 0x1e, 0x78, 0x60, 0x66, 0x3c, 0x00, 0x00, 0x00 ], -- s --?
  [ 0x00, 0x00, 0x0f, 0x1f, 0x18, 0x18, 0x18, 0x18, 0x7e, 0x7e, 0x18, 0x18, 0x18 ], -- t
  [ 0x00, 0x00, 0x7e, 0xe7, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0x00, 0x00, 0x00 ], -- u
  [ 0x00, 0x00, 0x18, 0x3c, 0x3c, 0x66, 0x66, 0xc3, 0xc3, 0xc3, 0x00, 0x00, 0x00 ], -- v
  [ 0x00, 0x00, 0xc3, 0xe7, 0xff, 0xff, 0xdb, 0xdb, 0xc3, 0xc3, 0x00, 0x00, 0x00 ], -- w
  [ 0x00, 0x00, 0xc3, 0x66, 0x3c, 0x18, 0x18, 0x3c, 0x66, 0xc3, 0x00, 0x00, 0x00 ], -- x
  [ 0xe0, 0x70, 0x38, 0x3c, 0x3c, 0x66, 0x66, 0xc3, 0xc3, 0xc3, 0x00, 0x00, 0x00 ], -- y
  [ 0x00, 0x00, 0xff, 0xc0, 0x60, 0x30, 0x18, 0x0c, 0x06, 0xff, 0x00, 0x00, 0x00 ]] -- z




-- ############################################################## --


charToGLubyte :: Char -> GLubyte
charToGLubyte = fromIntegral . castCharToCChar


makeRasterFont :: IO DisplayList
makeRasterFont = do
   rowAlignment Unpack $= 1

   fontDisplayLists@(fontOffset:_) <- genObjectNames 128
   let listsStartingWith ch = genericDrop (charToGLubyte ch) fontDisplayLists
       makeLetter dl letter =
          defineList dl Compile $
             withArray letter $
                bitmap (Size 8 13) (Vertex2 0 2) (Vector2 10 0)

   zipWithM_ makeLetter (listsStartingWith 'A') upperLetters
   zipWithM_ makeLetter (listsStartingWith 'a') lowerLetters
   zipWithM_ makeLetter (listsStartingWith ' ') symbols
   return fontOffset


myInit :: IO DisplayList
myInit = do
   shadeModel $= Flat
   makeRasterFont


printString :: DisplayList -> String -> IO ()
printString fontOffset s =
   preservingAttrib [ ListAttributes ] $ do
      listBase $= fontOffset
      withArray (map charToGLubyte s) $
        callLists (genericLength s) UnsignedByte

newStr :: [Char]
newStr = ""


printText :: DisplayList -> [String] -> (GLint,GLint) -> IO ()
printText fontOffset [] (x,y) = return ()
printText fontOffset (str:str') (x,y) = do
    let rasterPos2i = rasterPos :: Vertex2 GLint -> IO ()
    rasterPos2i (Vertex2 x y)
    printString fontOffset str
    printText fontOffset str' (x,y-15)




